#include <dos.h>
#include <io.h>
#include <mem.h>
#include <stdio.h>
#include <fcntl.h>
#include "include/svga.h"
#include "protos/svga_pr.h"
#include "include/bmp.h"

UWORD ReadFileHeader (LONG bmpfile, BITMAPFILEHEADER* bmfh){

 LONG bytes=0;
 lseek(bmpfile, 0L, SEEK_SET); // mi posiziono all'inizio del file

 if ((bytes = read(bmpfile, bmfh, sizeof(BITMAPFILEHEADER))) == -1) {
  printf("ReadFileHeader Failed.\n");
  return(0);
  }
 else {
  // ALL OK!
  //printf("ReadFileHeader: %d bytes read.\n", bytes);
  return(bytes);
  }
}

UWORD ReadInfoHeader (LONG bmpfile, BITMAPINFOHEADER* bmih){

 LONG bytes=0;

 if ((bytes = read(bmpfile, bmih, sizeof(BITMAPINFOHEADER))) == -1) {
  printf("ReadInfoHeader Failed.\n");
  return(0);
  }
 else {
  // ALL OK!
  //printf("ReadInfoHeader: %d bytes read.\n", bytes);
  return(bytes);
  }
}

void DisplayFileHeader (BITMAPFILEHEADER *bmfh){

	printf("-+* BITMAPFILEHEADER *+-\n");
	printf("bfType		=%d\n",bmfh->bfType);
	printf("bfSize		=%d\n",bmfh->bfSize);
	printf("bfReserved1	=%d\n",bmfh->bfReserved1);
	printf("bfReserved2	=%d\n",bmfh->bfReserved2);
	printf("bfOffBits	=%d\n",bmfh->bfOffBits);
	printf("-+* BITMAPFILEHEADER *+-\n\n");
}


void DisplayInfoHeader (BITMAPINFOHEADER *bmih){

	printf("-+* BITMAPINFOHEADER *+-\n");
	printf("biSize		=%ld\n",bmih->biSize);
	printf("biWidth		=%ld\n",bmih->biWidth);
	printf("biHeight	=%ld\n",bmih->biHeight);
	printf("biPlanes	=%d\n",bmih->biPlanes);
	printf("biBitCount	=%d\n",bmih->biBitCount);
	printf("biCompression   =%ld\n",bmih->biCompression);
	printf("biSizeImage   	=%ld\n",bmih->biSizeImage);
	printf("biXPelsPerMeter =%ld\n",bmih->biXPelsPerMeter);
	printf("biYPelsPerMeter =%ld\n",bmih->biYPelsPerMeter);
	printf("biClrUsed   	=%ld\n",bmih->biClrUsed);
	printf("biClrImportant  =%ld\n",bmih->biClrImportant);
	printf("-+* BITMAPINFOHEADER *+-\n\n");
}

void CheckBMP (LONG handle,
		BITMAPINFOHEADER* bmih,
		BITMAPFILEHEADER* bmfh){

 ReadFileHeader(handle,bmfh);
 ReadInfoHeader(handle,bmih);
 DisplayFileHeader(bmfh);
 DisplayInfoHeader(bmih);
}

LONG LoadBackground (UBYTE *fname, UBYTE far* svga ,
		  BITMAPINFOHEADER *bmih,
		  BITMAPFILEHEADER *bmfh,
		  MODEINFOBLOCK* MInfo){

 UWORD bytes=0;
 ULONG count=0;
 LONG bmpfile=0;
 UWORD bank=0;
 UBYTE far*orsvga=svga;


 if ((bmpfile = open(fname, O_RDONLY | O_BINARY)) == -1)
 {
   perror("Open Error:");
   return(-1L);
 }

 ReadFileHeader(bmpfile,bmfh); // leggo le intestazioni del file
 ReadInfoHeader(bmpfile,bmih);
 lseek(bmpfile ,bmfh->bfOffBits ,SEEK_SET); //la prossima lettura avverra' nei dati veri

 SetSVGABank(bank,MInfo);
 while(bank<8){

  for(count=0;count<64;count++){
   if (_dos_read(bmpfile,svga,640,&bytes) != 0){
    close(bmpfile);
    return(-2L); //errore !!;
   }
   else svga+=1024;

   }

 bank++;
 svga=orsvga;
 SetSVGABank(bank,MInfo);

 }

 SetSVGABank(0x00,MInfo);
 close(bmpfile);
 return(count);

}