#include "include/svga.h"
#include "protos/svga_pr.h"
#include "include/font.h"
#include "include/graph.h"
#include "protos/xms32_pr.h"
#include "include/pcx.h"
#include <dos.h>

extern UWORD oldbank;
extern UBYTE shbank;

//****************
// SVGA ---> XMS
//****************
//le seguenti routines servono per fare il "cut&paste" della memoria video nella
//memoria "normale"

void CopyLineHor (register UWORD x ,register UWORD y ,register UWORD len ,
		  UBYTE far *buffer ,MODEINFOBLOCK* MInfo, ULONG meminc ){

 UWORD xt=x,yt=y;
 ULONG offstart;
 UWORD bankstart,rwin;
 void (*WinFuncPtr)(void)=MInfo->WinFuncPtr; // funzione BankSwitching

 offstart=(ULONG)yt*(ULONG)MInfo->XResolution+xt;
 bankstart=(UWORD)(offstart>>16L);

 if((MInfo->WinBSegment)!=0) rwin=0x01;
  else rwin=0x00;
 // aperta parentesi: con 0x01 vuol dire che seleziono la seconda finestra
 // che la scheda mi mette a disposizione, se la scheda ha una finestra sola
 // (WinBSegment = 0) allora bisogna mettere 0x00

 asm mov ebx,dword ptr buffer   // la memoria xms
 asm mov edx,0x0a0000 // punta alla solita vecchia memoria video.. ;)
 asm mov edi,dword ptr offstart // parto dal giusto offset in memoria video
 asm and edi,0xffff   // faccio conto di essere nel banco 0
 asm mov esi,dword ptr meminc   // e in memoria "normale"
 asm mov ecx,len      // la lunghezza dei dati da copiare
 asm xor eax,eax      // azzera eax
 asm mov gs,eax       // azzera gs

 // caso SCHEGGIANTE!
 asm pushad
 asm mov bx,word ptr rwin
 asm mov dx,bankstart

 if(shbank!=0) asm shl dx,4

 asm call dword ptr WinFuncPtr
 asm popad

XCHK:
 asm mov al,byte ptr gs:[edx+edi]  // svga -> al
 asm mov byte ptr gs:[ebx+esi],al  // al   -> xms
 asm inc edi    // leggo il prossimo byte video
 asm inc esi    // nel prossimo byte memoria "normale"
 asm loop XCHK  // legge "len" byte

 if(!rwin) oldbank=bankstart;

 // siccome questa routine cambia il banco lo deve notificare
 // nella variabile globale "oldbank" altrimenti nascono
 // incomprensioni di vari genere con PutPixel()
 // che crede di essere in un banco invece e' in un'altro!
 // lo so che fa schifo avere quella variabilaccia globale
 // a zonzo per il codice, ma ora non ho voglia di pensare
 // a qualcosa di meglio, voglio finire il prg per avere
 // un aumento di stipendio!!!
}

void CopyRect ( WINPARAMS* winp ){

 UWORD y=winp->ory,ytemp;
 UWORD y1=winp->ory1;
 UWORD x1=winp->orx1;
 UWORD x=winp->orx;
 ULONG meminc=0;
 UWORD len=x1-x+1;

 x1++;y1++;

 for(ytemp=y;ytemp<y1;ytemp++){
  CopyLineHor(x,ytemp,len,winp->bgbuff,winp->MInfo,meminc);
  meminc+=len; // incrementa in memoria
 }

}

// ******************************************************************
//* XMS ---> SVGA                                                    *
// ******************************************************************
//le seguenti routines servono per fare il "cut&paste" della memoria "normale"
//nella memoria video.

void PasteLineHor (register UWORD x ,register UWORD y ,register UWORD len ,
		UBYTE far *buffer ,MODEINFOBLOCK* MInfo ,ULONG meminc){

 UWORD xt=x,yt=y;
 ULONG offstart;
 UWORD bankstart;
 void (*WinFuncPtr)(void)=MInfo->WinFuncPtr;


 offstart=(ULONG)yt*(ULONG)MInfo->XResolution+xt;
 bankstart=(UWORD)(offstart>>16L);


 asm mov ebx,buffer   // la memoria xms
 asm mov edx,0a0000h  // punta alla solita vecchia memoria video.. ;)
 asm mov edi,offstart // giusto offset in video
 asm and edi,0ffffh   // faccio conto di essere nel banco 0
 asm mov esi,dword ptr meminc   // giusto offset in memoria
 asm mov ecx,len      // lunghezza della linea da disegnare
 asm xor eax,eax
 asm mov gs,eax       // azzera gs

 // caso SCHEGGIANTE!  (e funzionante)
 asm pushad
 asm xor bx,bx
 asm mov dx,bankstart

 if(shbank!=0) asm shl dx,4

 asm call dword ptr WinFuncPtr
 asm popad

XCHK:
 asm mov al,byte ptr gs:[ebx+esi]   //xms -> al
 asm mov byte ptr gs:[edx+edi],al //al  -> svga
 asm inc edi    // leggo il prossimo byte dalla memoria
 asm inc esi    // e lo metto in video
 asm loop XCHK  // legge "len" byte

 oldbank=bankstart;
 // siccome questa routine cambia il banco lo deve notificare
 // nella variabile globale "oldbank" altrimenti nascono
 // incomprensioni di vari genere con PutPixel()
 // che crede di essere in un banco invece e' in un'altro!
}

void PasteRect (WINPARAMS* winp){

 UWORD y=winp->ory,ytemp;
 UWORD y1=winp->ory1;
 UWORD x1=winp->orx1;
 UWORD x=winp->orx;
 ULONG meminc=0;
 UWORD len=x1-x+1;

 y1++;x1++;
 for(ytemp=y;ytemp<y1;ytemp++){
   PasteLineHor(x,ytemp,len,winp->bgbuff,winp->MInfo,meminc);
   meminc+=len;
 }

}

void PutSymbol(register UWORD x ,register UWORD y ,
		   PCXIMAGE* symbol  ,MODEINFOBLOCK* MInfo){

 UWORD xt=x,yt=y,cicle,inner;
 ULONG offstart;
 UWORD bankstart;
 UBYTE col=symbol->ckey;
 UBYTE far* img=symbol->buffer;
 UBYTE far* vgamem=(UBYTE far*)MK_FP(0xa000,0); //(punta alla svga)

 for (cicle=0;cicle<32;cicle++){
  offstart=(ULONG)(yt++)*(ULONG)MInfo->XResolution+xt;
  bankstart=(UWORD)(offstart>>16L);
  SetSVGABank(bankstart,MInfo);
   for(inner=0;inner<32;inner++)
   {
    if(*(img)==col) {offstart++;img++;} //non disegnare questo pixel!
    else *(vgamem+(offstart++))=*img++;
   }
 }
 oldbank=bankstart;
 // siccome questa routine cambia il banco lo deve notificare
 // nella variabile globale "oldbank" altrimenti nascono
 // incomprensioni di vari genere con PutPixel()
 // che crede di essere in un banco invece e' in un'altro!
}
