#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <fcntl.h>
#include <alloc.h>
#include "include/svga.h"
#include "include/font.h"
#include "include/graph.h"
#include "protos/graph_pr.h"

#define MAX_TILES 256
#define X_MAX 8
#define Y_MAX 8

//grazie ha queste routines posso creare una directory "font" nel mio
//pseudo sistema operativo e caricarmi dei font un po' piu' carini di
//di quelli a disposizione della VGA.

BYTE AllocFontMem(FONTTYPE *myfont,UBYTE width)
{
 UWORD a, b;

// il font  dichiarato in font.h
 myfont->fontaddr=0;
 myfont->fontaddr=farmalloc((long)MAX_TILES*width);
 if (myfont->fontaddr==NULL)
 {
  printf("Errore nell'allocazione dei puntatori ai fonts.\n");
  return(-1);
 }

 return(0);
}

void FreeFontMem(FONTTYPE *myfont)
{
 int a, b;

 if (myfont->fontaddr!=NULL) farfree(myfont->fontaddr);
}

BYTE LoadFont(char *filename,FONTTYPE* myfont,UBYTE fontsize)
{

/* carica il font */

 UBYTE buf[80];
 ULONG itemsread;
 WORD file;
 UWORD a, b;
 UBYTE far* faddr;

 AllocFontMem(myfont,fontsize);
 faddr=myfont->fontaddr;


 sprintf(buf,"%s",filename);

 if (_dos_open(buf,O_RDONLY|O_BINARY,&file)!=0)
 {
  printf("Unable to open %s for read.\n",buf);
  return (-1);
 }

 myfont->fonthandle=file;
 for (a=0;a<256;a++){
  _dos_read(myfont->fonthandle,faddr,fontsize,(unsigned*)&itemsread);
  faddr+=fontsize;
 }

 myfont->fontwidth=fontsize;  /* modificare!*/
 myfont->fontheight=8;

 _dos_close(myfont->fonthandle);

 return(0);
}


void PutFont(UWORD x, UWORD y, UBYTE ascii, WORD colorfg ,WORD colorbg ,
		FONTTYPE* font,MODEINFOBLOCK* MInfo)
{

/* set up tileseg and tileoff with the segment and offset of the font */
/* scrnseg and scrnoff contain the segment and offset of the screen buffer
   which, if I assigned it to Video Mem, would be 0xA000 and 0x0000
   respectively */

 UBYTE far* buffer=(UBYTE far*)MK_FP(0xa000,0x0000);
 UBYTE far* faddr=font->fontaddr;
 UBYTE dat,i,j;
 ULONG fontoff=ascii*font->fontwidth;


 for(i=0;i<font->fontwidth;i++){

   dat=faddr[fontoff+i];  /* 8byte del carattere*/
   //printf("dat=%ld\n",dat);
   for(j=0;j<8;j++){     /* 8bit del carattere */

    if(dat&0x80) PutPixel(x+j,y+i,colorfg,buffer,MInfo); //colore del testo
     else if(colorbg!=-1) PutPixel(x+j,y+i,colorbg,buffer,MInfo); //colore di sfondo
    dat=dat<<1;

   }

 }


}


void PutString(UWORD x, UWORD y, char *string, WORD colorfg, WORD colorbg, FONTTYPE* font,
		MODEINFOBLOCK* MInfo)
{
 UWORD a=0;

 while (string[a]!='\0')
 {
  PutFont(x,y,string[a],colorfg,colorbg,font,MInfo);
  x+=8;
  a++;
 }
}

void PutNumber(UWORD x, UWORD y, LONG number, WORD colorfg, WORD colorbg, FONTTYPE* font,
		MODEINFOBLOCK* MInfo)
{
 UBYTE buf[17];

 itoa(number,buf,10);
 PutString(x,y,buf,colorfg,colorbg,font,MInfo);
}