#include <dos.h>
#include <mem.h>
#include <stdio.h> //per lo sprintf()
#include "include/svga.h"
#include "protos/svga_pr.h"
#include "include/font.h"
#include "protos/font_pr.h"
#include "include/graph.h"
#include "protos/xms32_pr.h"
#include "protos/cutp_pr.h"
#include "include/keybhand.h"
#include "protos/keybh_pr.h"
#include "include/pcx.h"
#include "protos/pcx_pr.h"

UWORD oldbank=0;
UBYTE shbank;

extern PCXIMAGE prt_img;
extern PCXIMAGE err_img;
extern PCXIMAGE ser_img;
extern PCXIMAGE keyb_img;
extern PCXIMAGE arch_img;
extern PCXIMAGE arm_img;
extern PCXIMAGE app_img;

//qui ci sono tutte le primitive grafiche del mio pseudo OS.

void PutPixel (register UWORD x ,register UWORD y ,register UBYTE col,
		   register UBYTE far *buffer,
		   register MODEINFOBLOCK* MInfo){

     ULONG offset=(ULONG)y*(MInfo->XResolution)+x;
     UWORD bank=(UWORD)(offset>>16);
     void far* WinFuncPtr=MInfo->WinFuncPtr;

     if(oldbank!=bank){

      oldbank=bank;

      asm push bx
      asm push dx
      asm xor bx,bx
      asm mov dx,bank
      if(shbank!=0) asm shl dx,4
      asm call dword ptr WinFuncPtr
      asm pop dx
      asm pop bx

     }

     buffer[offset & 0xffff]=col;

}

UBYTE GetPixel (register UWORD x ,register UWORD y ,
		 register UBYTE far *buffer,
		  register MODEINFOBLOCK* MInfo){

     ULONG offset=(ULONG)y*(MInfo->XResolution)+x;
     UWORD bank=(UWORD)(offset>>16);
     UBYTE col;
     UWORD rwin;
     void far* WinFuncPtr=MInfo->WinFuncPtr;

     if((MInfo->WinBSegment)!=0) rwin=0x01;
      else rwin=0x00;


     if(oldbank!=bank){


      oldbank=bank;

      _asm{
	mov bx,rwin // nel caso che readwin!=writewin
	mov dx,bank
	mov cl,shbank
	shl dx,cl
	call dword ptr WinFuncPtr
	}

     }

     col=buffer[offset & 0xffff];
     return(col);
}

void LineHor (UWORD x ,UWORD y ,UWORD len ,UBYTE col ,UBYTE far *buffer,
		MODEINFOBLOCK* MInfo ){

 UWORD xtemp;
 ULONG offstart=(ULONG)y*(MInfo->XResolution)+x;
 UWORD bankstart=(UWORD)(offstart>>16);
 void far* WinFuncPtr=MInfo->WinFuncPtr;

 asm{  // caso SCHEGGIANTE!
	xor bx,bx
	mov dx,bankstart
	mov cl,shbank
	shl dx,cl
	call dword ptr WinFuncPtr
 }

 _fmemset(buffer+(offstart&0xffff),col,len);

 oldbank=bankstart;
 // siccome questa routine cambia il banco lo deve notificare
 // nella variabile globale "oldbank" altrimenti nascono
 //incomprensioni di vari genere con PutPixel()
 // che crede di essere in un banco invece e' in un'altro!
}

void LineVert (UWORD x ,UWORD y ,UWORD len ,UBYTE col ,UBYTE far *buffer,
		MODEINFOBLOCK* MInfo ){

 UWORD ytemp;

 for(ytemp=y;ytemp<y+len;ytemp++) PutPixel(x,ytemp,col,buffer,MInfo);

}

void RectFill (UWORD x ,UWORD y ,UWORD x1 ,UWORD y1, UBYTE col ,
	       UBYTE far* buffer, MODEINFOBLOCK* MInfo ){

 UWORD ytemp;

 for(ytemp=y;ytemp<y1;ytemp++) LineHor(x,ytemp,x1-x,col,buffer,MInfo);

}

void Rect (UWORD x ,UWORD y ,UWORD x1 ,UWORD y1, UBYTE col ,
	   UBYTE far* buffer ,MODEINFOBLOCK* MInfo ){

 LineHor(x,y,x1-x,col,buffer,MInfo);
 LineHor(x,y1,x1-x,col,buffer,MInfo);

 for(;y<=y1;y++){
	PutPixel (x,y,col,buffer,MInfo);
	PutPixel (x1,y,col,buffer,MInfo);
	}

}

LONG OpenWindow (UWORD x ,UWORD y ,UWORD x1 ,UWORD y1,WINPARAMS* winp){

 ULONG needmem=0,diffx,diffy;

 if((x>winp->MInfo->XResolution-20)||(x>x1)) return(-1L);
 if((y>winp->MInfo->YResolution-20)||(y>y1)) return(-2L);
 if(x1>winp->MInfo->XResolution-20) return(-4L);
 if(y1>winp->MInfo->YResolution-20) return(-5L);

 // copio le coordinate originali per il grabbing del background
 winp->orx=x;winp->ory=y;
 winp->orx1=x1;winp->ory1=y1;

 // Alloco la memoria per la finestra
 XMS32LocEnA20(); // solita menata della linea....
 diffx=x1-x;
 diffy=y1-y;
 needmem=(diffx*diffy)>>10; // mem da allocare in kbytes..
 needmem+=2; 		    // ..almeno due kbyte per forza!
			    // arrotondo per eccesso.
 //printf("NeedMem = %d\n",needmem);
 winp->bghandle=XMS32Alloc(needmem); // alloco memoria
 winp->bgbuff=(UBYTE far*)XMS32Lock(winp->bghandle); // indirizzo fisico 32bit

 //.. e grabbo il background..
 CopyRect(winp);

 switch(winp->mode){
	case MWIN:
		Rect (x,y,x1,y1,55,winp->buffp,winp->MInfo);
		Rect (x,y,x1,y+9,55,winp->buffp,winp->MInfo);

		RectFill (x+1,y+1,x1,y+9,55,winp->buffp,winp->MInfo);
		LineHor (x,y,x1-x,24,winp->buffp,winp->MInfo);
		LineVert(x1,y,9,0,winp->buffp,winp->MInfo);

		RectFill (x+1,y+10,x1,y1,23,winp->buffp,winp->MInfo); //grigio
		LineHor (x,y+10,x1-x,0,winp->buffp,winp->MInfo);
		LineVert (x1,y+10,y1-y-10,24,winp->buffp,winp->MInfo);

		//ora gli faccio ritornare le coordinate
		//del rettamgolo entro il quale puo' scrivere del testo ;)
		winp->x=x+3;
		winp->y=y+10;
		winp->x1=x1-2;
		winp->y1=y1-2;
		break;
	case WIN95:
	default:
		//ora gli faccio ritornare le coordinate
		//del rettamgolo entro il quale puo' scrivere del testo ;)
		winp->x=x+3;
		winp->y=y+18;
		winp->x1=x1-2;
		winp->y1=y1-2;

		//disegno la finestra..
		Rect (x,y,x1,y1,18,winp->buffp,winp->MInfo);
		Rect (x+1,y+1,x1-1,y1-1,25,winp->buffp,winp->MInfo);

		LineHor (x,y,x1-x,28,winp->buffp,winp->MInfo);
		LineHor (x+1,y+1,x1-x-1,30,winp->buffp,winp->MInfo);
		LineVert(x,y,y1-y,28,winp->buffp,winp->MInfo);
		LineVert(x+1,y+1,y1-y-1,30,winp->buffp,winp->MInfo);
		RectFill (x+2,y+2,x1-1,y1-1,28,winp->buffp,winp->MInfo);
		RectFill (x+4,y+4,x1-3,y+16,33,winp->buffp,winp->MInfo);

		//.. stampo il titolo ..
		PutString(x+6,y+6,winp->wintitle,14,-1,winp->fonttype,winp->MInfo);

		//..e ora disegno i due finti bottoni :)

		RectFill (x1-27,y+5,x1-17,y+15,28,winp->buffp,winp->MInfo);
		Rect (x1-27,y+5,x1-18,y+14,18,winp->buffp,winp->MInfo);
		LineHor (x1-27,y+5,10,30,winp->buffp,winp->MInfo);
		LineVert (x1-27,y+5,9,30,winp->buffp,winp->MInfo);
		LineHor(x1-25,y+12,6,18,winp->buffp,winp->MInfo);
		LineHor(x1-25,y+11,6,18,winp->buffp,winp->MInfo);

		RectFill (x1-15,y+5,x1-5,y+15,28,winp->buffp,winp->MInfo);
		Rect (x1-15,y+5,x1-6,y+14,18,winp->buffp,winp->MInfo);
		LineHor (x1-15,y+5,10,30,winp->buffp,winp->MInfo);
		LineVert (x1-15,y+5,9,30,winp->buffp,winp->MInfo);
		Rect (x1-13,y+7,x1-8,y+12,18,winp->buffp,winp->MInfo);
		LineHor (x1-13,y+8,6,18,winp->buffp,winp->MInfo);

		break;
	}

 return(0L);
}

ULONG Button (UWORD x ,UWORD y ,UBYTE *string ,UBYTE far* buffp ,
	       FONTTYPE *ftype, MODEINFOBLOCK* MInfo){

 UWORD a=0,width=0;
 ULONG lenght=0;

 while (string[a]!='\0') a++; /* quanti caratteri mi hai passato? */
 lenght=(a*8)+4; /* il bottone deve essere lungo cos */
 width=8+8+4;    /* e largo cosi' (per ora larghezza fissa)*/

 Rect (x,y,x+lenght,y+width,18,buffp,MInfo);
 Rect (x+1,y+1,x+lenght-1,y+width-1,25,buffp,MInfo);
 LineHor (x,y,lenght,26,buffp,MInfo);
 LineHor (x+1,y+1,lenght-1,30,buffp,MInfo);
 LineVert(x,y,width,26,buffp,MInfo);
 LineVert(x+1,y+1,width-1,30,buffp,MInfo);
 RectFill (x+2,y+2,x+lenght-1,y+width-1,28,buffp,MInfo);

 //previsto lo spazio per scrivere 2 linee in un bottone
 PutString(x+3,y+7,string,0x00,28,ftype,MInfo);

 return(lenght+2);
}

void TaskBar (UBYTE *btext[] ,UBYTE far* buffp ,
		FONTTYPE *ftype,MODEINFOBLOCK* MInfo){

 UBYTE a=0;
 ULONG nextpos=0,inc=0;

 RectFill (0,453,640,480,28,buffp,MInfo);
 LineHor (0,454,640,30,buffp,MInfo);

 // ora disegno il rettangolino per l'ora:
 Rect(590,457,637,477,18,buffp,MInfo);
 LineHor (590,477,48,30,buffp,MInfo);
 LineVert(637,457,20,30,buffp,MInfo);
 // ecco fatto


 while(btext[a]!=0){
  nextpos=Button(2+inc,457,btext[a],buffp,ftype,MInfo);
  inc+=nextpos;
  a++;
 }

}


void TaskBarTime (FONTTYPE *ftype, MODEINFOBLOCK* MInfo){

 struct dostime_t t;
 UBYTE buf[80];

  _dos_gettime(&t);
  sprintf(buf,"%02d:%02d",t.hour,t.minute);
  PutString(593,461,buf,104,28,ftype,MInfo);

}

LONG CloseWindow (WINPARAMS* winp){

 // ricopiare il "rettangolo" al suo posto...
 PasteRect(winp);

 //printf("closewin \nx.%d y.%d x1.%d y1.%d",winp->x,winp->y,winp->x1,winp->y1);

 //...e deallocare la memoria
 XMS32Unlock(winp->bghandle);
 XMS32Free(winp->bghandle);
 winp->bghandle=0;

 // ritornare un codice adeguato alla situazione
 return(0L);
}

LONG ErrorWin (STRPTR title ,
	       STRPTR line1 ,STRPTR line2 ,STRPTR line3 ,
	       MODEINFOBLOCK* MInfo ,FONTTYPE* ftype){

 WINPARAMS errwin;

 errwin.buffp=(UBYTE far*)MK_FP(0xa000,0); //(punta alla svga)
 errwin.mode=WIN95;
 errwin.MInfo=MInfo;
 errwin.wintitle=title;
 errwin.fonttype=ftype; // poi si vedra'

 OpenWindow(160,120,480,210,&errwin);

 PutSymbol(errwin.x+5,errwin.y+1,&err_img,MInfo);
 PutString(errwin.x+40,errwin.y+2,line1,0,-1,ftype,MInfo);
 PutString(errwin.x+40,errwin.y+12,line2,0,-1,ftype,MInfo);
 PutString(errwin.x+40,errwin.y+22,line3,0,-1,ftype,MInfo);
 Button(errwin.x+100,errwin.y+40,"PREMERE [ESC]",errwin.buffp,ftype,MInfo);

 WaitKey(ESC_KEY);

 CloseWindow(&errwin);
 return(0);
}