/***************************
 INCLUDE FILE

 -SVGA STRUCTURES
 _TYPEDEFS
****************************/

typedef unsigned char UBYTE;
typedef char           BYTE;
typedef unsigned int  UWORD;
typedef int            WORD;
typedef unsigned long ULONG;
typedef long           LONG;
typedef char *	     STRPTR;

typedef struct VGAInfoBlock {

 UBYTE  VESASignature[4];
 UWORD  VESAVersion     ; //VESA version number
 BYTE far* OEMStringPtr    ; //Pointer to OEM string
 UBYTE  Capabilities[4] ; //capabilities of the video environment
 WORD far* VideoModePtr    ; //pointer to supported Super VGA modes
 UWORD TotalMemory      ; //Number of 64kb memory blocks on board
 UBYTE Reserved[236]    ; //Remainder of VgaInfoBlock
}VGAINFOBLOCK;

typedef struct ModeInfoBlock {
// mandatory information

	UWORD ModeAttributes;      //mode attributes
	UBYTE WinAAttributes;      //window A attributes
	UBYTE WinBAttributes;      //window B attributes
	UWORD WinGranularity;      //window granularity
	UWORD WinSize       ;      //window size
	UWORD WinASegment   ;      //window A start segment
	UWORD WinBSegment   ;      //window B start segment
	void far* WinFuncPtr;     //pointer to windor function
	UWORD BytesPerScanLine;    //bytes per scan line

//formerly optional information (now mandatory)

	UWORD XResolution;         //horizontal resolution
	UWORD YResolution;         //vertical resolution
	UBYTE XCharSize;           //character cell width
	UBYTE YCharSize;           //character cell height
	UBYTE NumberOfPlanes;      //number of memory planes
	UBYTE BitsPerPixel;        //bits per pixel
	UBYTE NumberOfBanks;       //number of banks
	UBYTE MemoryModel;         //memory model type
	UBYTE BankSize;            //bank size in kb
	UBYTE NumberOfImagePages;  //number of images
	UBYTE ReservedPage;         //1  ; reserved for page function

// new Direct Color fields

	UBYTE RedMaskSize;         //size of direct color red mask in bits
	UBYTE RedFieldPosition;    //bit position of LSB of red mask
	UBYTE GreenMaskSize;       //size of direct color green mask in bits
	UBYTE GreenFieldPosition;  //bit position of LSB of green mask
	UBYTE BlueMaskSize;        //size of direct color blue mask in bits
	UBYTE BlueFieldPosition;   //bit position of LSB of blue mask
	UBYTE RsvdMaskSize;        //size of direct color reserved mask in bits
	UBYTE DirectColorModeInfo; //Direct Color mode attributes
	UBYTE Reserved[216];      //remainder of ModeInfoBlock
}MODEINFOBLOCK;

/*Offset per il modo 640*480
inline void PutPixel (WORD x ,WORD y ,UBYTE col ,UBYTE huge *buffer){

 buffer[(y<<8)+(y<<8)+(y<<7)+x]=col;

}*/

static UBYTE* MemModel[8]={
	"Text mode",
	"CGA graphics",
	"Hercules graphics",
	"4-plane planar",
	"Packed pixel",
	"Non-chain 4, 256 color",
	"Direct Color",
	"YUV"
};

#define MWIN    0x01
#define WIN95   0x02

#define WHITE   15
#define BLACK   0

//per il monitor
#define WAKEUP   0x00
#define SHUTDOWN 0x01
#define NORMAL	 0x00
#define HIGH	 0x01

//Identificativi del CHIP VIDEO della CIRRUS:
static UBYTE*  CLChipID[0x52]={0};