#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include "include/svga.h"
#include "include/pcx.h"

WORD LoadPCX(BYTE* filename ,PCXIMAGE* image){

  FILE *infile;
  UBYTE far * ImagePtr;
  UWORD x, i=0;
  UWORD Points;
  WORD c;
  PCXHEADER pcxhead;


  if ((infile=fopen(filename,"rb"))==NULL) return(-2);

  //legge l'header del file PCX
  fseek(infile,0L,SEEK_SET);
  fread(&pcxhead,sizeof(PCXHEADER),1,infile);

  // riempie la struttura con i giusti valori
  image->xsize = (pcxhead.xmax-pcxhead.xmin) + 1;
  image->ysize = (pcxhead.ymax-pcxhead.ymin) + 1;
  image->ckey=0x0f; // cambiare qui per altro ChromaKey!!
  Points = image->xsize * image->ysize;

  // alloca spazio per l'immagine
  image->buffer = (char far *) farmalloc(Points);
  if(image->buffer==NULL) return(-3); // torna indietro se non hai memoria
  ImagePtr=image->buffer;
  for (i=0;i<Points;++i)
  {
    c=fgetc(infile) & 0xff;
    if((c & 0xc0) == 0xc0)
    {
      x=c & 0x3f;
      c=fgetc(infile);
      while(x--)
      {
	*(ImagePtr++)=c;
	i++;
      }
      i--;
    }
    else
    {
      *(ImagePtr++)=c;
    }
  }
  fclose(infile);
  return(0);
}

WORD FreePCX (PCXIMAGE* image){
 if(image->buffer==NULL) return(-3); // torna indietro se non hai memoria
  else farfree(image->buffer);
 return(0);
}

WORD DisplayPCXInfo (BYTE* filename){

  FILE *infile;
  PCXHEADER pcxhead;


  if ((infile=fopen(filename,"rb"))==NULL) return(-2);
  fseek(infile,0L,SEEK_SET);
  fread(&pcxhead,sizeof(PCXHEADER),1,infile);

  printf("SCANNING PCX File %s\n",filename);
  printf(" Manufacturer %d\n",pcxhead.manufacturer);
  printf(" Version %d\n",pcxhead.version);
  printf(" Bits_per_Pixel %d\n",pcxhead.bits_per_pixel);
  printf(" xmin %d,ymin %d\n",pcxhead.xmin,pcxhead.ymin);
  printf(" xmax %d,ymax %d\n",pcxhead.xmax,pcxhead.ymax);
  printf(" hres %d\n",pcxhead.hres);
  printf(" vres %d\n",pcxhead.vres);

  fclose(infile);
  return(0);
}
