#include <dos.h>
#include <mem.h>
#include <stdio.h>
#include "include/svga.h"

extern UBYTE shbank;

void SetMode (register UWORD mode){

 _asm{
	mov ax,mode
	int 0x10
     }// va' nel modo specificato
}

void WaitRetrace(void) {

  _DX = 0x03DA;

  l1: asm {
	in  al,dx;
	and al,0x08;
	jnz l1;
      }

  l2: asm {
	in  al,dx;
	and al,0x08;
	jz  l2;
      }
}

UWORD GetVGAInfo (VGAINFOBLOCK* VGABlock){

 UWORD code;
 UWORD segm=FP_SEG(VGABlock);
 UWORD off=FP_OFF(VGABlock);

 _asm{
	mov ax,segm
	mov es,ax
	mov di,off
	mov ax,0x4f00

	int 0x10
	mov code,ax
     }

 return(code);
}

UWORD GetModeInfo (MODEINFOBLOCK* ModeBlock ,UWORD mode ){

 UWORD code;
 UWORD segm=FP_SEG(ModeBlock);
 UWORD off=FP_OFF(ModeBlock);

 _asm{
	mov ax,segm
	mov es,ax
	mov di,off
	mov ax,0x4f01
	mov cx,mode

	int 0x10
	mov code,ax
     }

 return(code);
}


void ClrSVGA (UBYTE far* buffer ,UBYTE colore, MODEINFOBLOCK* MInfo){

 UWORD bank=0;
 void far* WinFuncPtr=MInfo->WinFuncPtr;

 while(bank!=8){

 _asm{
	mov bx,0x00
	mov dx,bank
	mov cl,shbank
	shl dx,cl   // Togliere questa istruzione se WinGran = 64K
	call dword ptr WinFuncPtr
     }
  _fmemset(buffer,colore,0xffff);
  buffer[65535]=colore;// non so' perche' ma qui
		       //_fmemset non mi ci arriva....
  bank++;

  }

  /* ... e prima di tornare rimetti il banco a 0 !!!! */
 _asm{
	mov bx,0x00
	mov dx,0x00
	call dword ptr WinFuncPtr
     }
}

void SetSVGABank (UWORD bank ,MODEINFOBLOCK* MInfo){

 void far* WinFuncPtr=MInfo->WinFuncPtr;

 _asm{
	mov bx,0x00
	mov dx,[bank]
	mov cl,shbank
	shl dx,cl
	call dword ptr WinFuncPtr
     }
}

UWORD SetScanLine(MODEINFOBLOCK* MInfo ,register UWORD width){

 UWORD maxlin;

 MInfo->XResolution=width; //Aggiorna la risoluzione

 _asm{
	mov ax,0x4f06
	mov bl,0x00
	mov cx,[width]  //setta la lunghezza di una linea dello schermo
	int 0x10
	mov [maxlin],dx     //ritorna il numero di linee in un banco
     }

 return(maxlin);
}

void SetDisplayStart(UWORD xoff ,UWORD yoff){

 _asm{
	mov ax,0x4f07
	mov bx,0x00
	mov cx,xoff
	mov dx,yoff
	int 0x10
     }
}

void SetSVGAMode (register UWORD mode){

 _asm{
	mov ax,0x4f02
	mov bx,mode
	int 0x10
     }// va' nel modo specificato SuperVGA

}

void DisplaySVGAInfo (VGAINFOBLOCK* VGAInfo, MODEINFOBLOCK* ModeInfo){

 UWORD mode=0;

 GetVGAInfo(VGAInfo);
 printf("%c%c%c%c %d.%d\n",VGAInfo->VESASignature[0],
		VGAInfo->VESASignature[1],
		VGAInfo->VESASignature[2],
		VGAInfo->VESASignature[3],
		(VGAInfo->VESAVersion)>>8,
		(VGAInfo->VESAVersion)&0xff);

 printf("OEM: %s\n",VGAInfo->OEMStringPtr);
 printf("Board Memory: %dKbytes\n",VGAInfo->TotalMemory<<6);

 printf("Supported Modes:\n");
 while((mode=*VGAInfo->VideoModePtr++)!=0xffff){

  printf("\nMODE: 0x%x\n",mode);

  GetModeInfo (ModeInfo,mode);
  printf("ModeAttributes=%d\n",ModeInfo->ModeAttributes);
  printf("MemoryModel   =%s\n",MemModel[ModeInfo->MemoryModel]);
  printf("WinGranularity=%d\n",ModeInfo->WinGranularity);
  printf("WinSize       =%d\n",ModeInfo->WinSize);
  printf("BytesPerScanLine =%d\n",ModeInfo->BytesPerScanLine);
  printf("WinASegment   =%x\n",ModeInfo->WinASegment);
  if((ModeInfo->WinAAttributes)&0x01) printf(" Window is supported.\n");
   else printf(" Window is not supported.\n");
  if((ModeInfo->WinAAttributes)&0x02) printf(" Window is readable.\n");
   else printf(" Window is not readable.\n");
  if((ModeInfo->WinAAttributes)&0x04) printf(" Window is writeable.\n");
   else printf(" Window is not writeable.\n");

  printf("WinBSegment   =%x\n",ModeInfo->WinBSegment);
  if((ModeInfo->WinAAttributes)&0x01) printf(" Window is supported.\n");
   else printf(" Window is not supported.\n");
  if((ModeInfo->WinAAttributes)&0x02) printf(" Window is readable.\n");
   else printf(" Window is not readable.\n");
  if((ModeInfo->WinAAttributes)&0x04) printf(" Window is writeable.\n");
   else printf(" Window is not writeable.\n");

  printf("WinFuncPtr    =%p\n",ModeInfo->WinFuncPtr);
  printf("XResolution   =%d\n",ModeInfo->XResolution);
  printf("YResolution   =%d\n",ModeInfo->YResolution);
 }
}


// questa routine funziona esclusivamente su una SVGA CIRRUSLOGIC con
// bios >= V3.02
void CLBlank(UBYTE status){

 asm mov ah,0x12
 asm mov bl,0x94
 asm mov al,byte ptr status //0 wakeup 1 shutdown
 asm int 0x10

}

void CLRefresh(UBYTE status){

 asm mov ah,0x12
 asm mov bl,0xa3
 asm mov al,byte ptr status //0 normal 1 high
 asm int 0x10

}

UBYTE CLAskChipID(void){

 UBYTE chipid;

  asm mov ah,0x12
  asm mov bl,0x80
  asm int 0x10
  asm mov byte ptr chipid,al

  return(chipid);

}

void CheckCirrus(void){

 UBYTE chipid;

 //riempo l'array con i valori corrispondenti dei chip
 CLChipID[2]="CL-GD 510/520";
 CLChipID[3]="CL-GD 610/620";
 CLChipID[4]="CL-GD 5320";
 CLChipID[5]="CL-GD 6410";
 CLChipID[6]="CL-GD 5410";
 CLChipID[7]="CL-GD 6420";
 CLChipID[8]="CL-GD 6412";
 CLChipID[9]="CL-GD 6416";
 CLChipID[0x10]="CL-GD 5401";
 CLChipID[0x11]="CL-GD 5402";
 CLChipID[0x12]="CL-GD 5420";
 CLChipID[0x13]="CL-GD 5422";
 CLChipID[0x14]="CL-GD 5424";
 CLChipID[0x15]="CL-GD 5426";
 CLChipID[0x16]="CL-GD 5420 rev 1";
 CLChipID[0x17]="CL-GD 5402 rev 1";
 CLChipID[0x18]="CL-GD 5428";
 CLChipID[0x19]="CL-GD 5429";
 CLChipID[0x20]="CL-GD 6205";
 CLChipID[0x21]="CL-GD 6215";
 CLChipID[0x22]="CL-GD 6225";
 CLChipID[0x23]="CL-GD 6235";
 CLChipID[0x24]="CL-GD 6245";
 CLChipID[0x30]="CL-GD 5432";
 CLChipID[0x31]="CL-GD 5434";
 CLChipID[0x32]="CL-GD 5430";
 CLChipID[0x33]="CL-GD 5434 (.6 micron)";
 CLChipID[0x40]="CL-GD 6440";
 CLChipID[0x41]="CL-GD 7542 (Nordic)";
 CLChipID[0x42]="CL-GD 7543 (Viking)";
 CLChipID[0x43]="CL-GD 7541 (Nordic Lite)";
 CLChipID[0x44]="CL-GD 5452 (Northstar)";

 //CONTROLLO SE E' UNA CL 54XX
 chipid=CLAskChipID();
 if(chipid!=0)
  printf(" CHIP_ID is %d\n",CLChipID[chipid]);
 return;
}

void DisplayVESAInfo (VGAINFOBLOCK* VGAInfo){

 GetVGAInfo(VGAInfo);
 printf("VIDEO HARDWARE DETECTED:\n");
 printf(" %c%c%c%c %d.%d\n",VGAInfo->VESASignature[0],
		VGAInfo->VESASignature[1],
		VGAInfo->VESASignature[2],
		VGAInfo->VESASignature[3],
		(VGAInfo->VESAVersion)>>8,
		(VGAInfo->VESAVersion)&0xff);

 printf(" OEM: %s\n",VGAInfo->OEMStringPtr);
 printf(" Board Memory: %dKbytes\n",VGAInfo->TotalMemory<<6);
}

void DisplayModeInfo (VGAINFOBLOCK* VGAInfo, MODEINFOBLOCK* ModeInfo ,UWORD mode){

 DisplayVESAInfo(VGAInfo);

 CheckCirrus();

 GetModeInfo (ModeInfo,mode);
 //printf("ModeAttributes=%d\n",ModeInfo->ModeAttributes);
 //printf("MemoryModel   =%s\n",MemModel[ModeInfo->MemoryModel]);
 printf(" WinGranularity=%d\n",ModeInfo->WinGranularity);
 //printf("WinSize       =%d\n",ModeInfo->WinSize);
 //printf("BytesPerScanLine =%d\n",ModeInfo->BytesPerScanLine);
 printf(" WinASegment   =%x\n",ModeInfo->WinASegment);
 printf(" WinBSegment   =%x\n",ModeInfo->WinBSegment);
 printf(" WinFuncPtr    =%p\n",ModeInfo->WinFuncPtr);
 //printf("NumberOfBanks =%d\n",ModeInfo->NumberOfBanks);
 printf(" XResolution   =%d\n",ModeInfo->XResolution);
 printf(" YResolution   =%d\n",ModeInfo->YResolution);
}

void GetPalette(UBYTE colnum ,UBYTE* R ,UBYTE* G ,UBYTE* B){

 outp(0x3c7,colnum);
 *R=inp(0x3c9);
 *G=inp(0x3c9);
 *B=inp(0x3c9);
}

void SetPalette(UBYTE colnum ,UBYTE R ,UBYTE G ,UBYTE B){

 outp(0x3c8,colnum);
 outp(0x3c9,R);
 outp(0x3c9,G);
 outp(0x3c9,B);
}

void BlackOut(void){

 UBYTE pal=0xff;

 for(pal=0;pal<0xff;pal++){
  WaitRetrace();
  SetPalette(pal,0,0,0);
 }
}

UBYTE Pall[255][3];

void GrabPalette(void){

 UWORD loop1;
 for(loop1=0;loop1<255;loop1++)
    GetPalette (loop1,&Pall[loop1][1],&Pall[loop1][2],&Pall[loop1][3]);
}

void FadeDown(void){

 UWORD loop1,loop2;
 UBYTE Tmp[3]; //variabile temporanea per il valore di un colore

  for(loop1=1;loop1<64;loop1++){
    WaitRetrace();
    for(loop2=0;loop2<255;loop2++){
      GetPalette (loop2,&Tmp[1],&Tmp[2],&Tmp[3]);
      if(Tmp[1]>0) Tmp[1]--;
      if(Tmp[2]>0) Tmp[2]--;
      if(Tmp[3]>0) Tmp[3]--;
	//Se i valori del rosso, verde o blu dentro loop2 non sono ancora zero,
	//allora decrementali di uno.
      SetPalette (loop2,Tmp[1],Tmp[2],Tmp[3]);
	//Setta la nuova palette cos modificata.
    }
  }
}

void FadeUp(void){

 UWORD loop1,loop2;
 UBYTE Tmp[3]; //variabile temporanea per il valore di un colore

  for(loop1=1;loop1<64;loop1++){
      //{ A color value for Red, green or blue is 0 to 63, so this loop only
      //  need be executed a maximum of 64 times }
    WaitRetrace();
    for(loop2=0;loop2<255;loop2++){
      GetPalette(loop2,&Tmp[1],&Tmp[2],&Tmp[3]);
      if(Tmp[1]<Pall[loop2][1]) Tmp[1]++;
      if(Tmp[2]<Pall[loop2][2]) Tmp[2]++;
      if(Tmp[3]<Pall[loop2][3]) Tmp[3]++;
	//Se i valori del rosso, verde o blu dentro loop2 sono minori di come dovranno essere,
	//allora incrementali di uno.
      SetPalette(loop2,Tmp[1],Tmp[2],Tmp[3]);
	//Setta la nuova palette cos modificata.
    }
  }
}

void RestorePalette(void){
  //Questa procedura effettua il restore della palette originale
 UWORD loop1;

 WaitRetrace();
 for(loop1=0;loop1<255;loop1++)
    SetPalette (loop1,Pall[loop1][1],Pall[loop1][2],Pall[loop1][3]);
}

